[![Travis](https://img.shields.io/travis/mediamonks/seng-keycodes.svg?maxAge=2592000)](https://travis-ci.org/mediamonks/seng-keycodes)
[![Code Climate](https://img.shields.io/codeclimate/github/mediamonks/seng-keycodes.svg?maxAge=2592000)](https://codeclimate.com/github/mediamonks/seng-keycodes)
[![Coveralls](https://img.shields.io/coveralls/mediamonks/seng-keycodes.svg?maxAge=2592000)](https://coveralls.io/github/mediamonks/seng-keycodes?branch=master)
[![npm](https://img.shields.io/npm/v/seng-keycodes.svg?maxAge=2592000)](https://www.npmjs.com/package/seng-keycodes)
[![npm](https://img.shields.io/npm/dm/seng-keycodes.svg?maxAge=2592000)](https://www.npmjs.com/package/seng-keycodes)

# seng-keycodes

Contains the key codes as static values for keys on your keyboard. Useful for auto completion and readability.


## Installation

### npm

```sh
npm i -S seng-keycodes
```

### other

We also have browser, amd, commonjs, umd, systemjs and es6 versions of
this module available attached to the [Github Releases](https://github.com/mediamonks/seng-keycodes/releases).

<!---

Note: The below cannot be used yet, as there is no way to link to a
specific version yet without updating this readme manually after each
new version.


### browser

```html
<script src="http://mediamonks-development.s3.amazonaws.com/seng/libs/seng-keycodes/1.2.0/seng-keycodes.min.js"></script>
```
```js
console.log(window.SengKeycodes)
```

### other

Besides the browser version, there are other versions available for
download as well:

- [browser](http://mediamonks-development.s3.amazonaws.com/seng/libs/seng-keycodes/1.2.0/seng-keycodes.js) (and [minified](http://mediamonks-development.s3.amazonaws.com/seng/libs/seng-keycodes/1.2.0/seng-keycodes.min.js))
- [umd](http://mediamonks-development.s3.amazonaws.com/seng/libs/seng-keycodes/1.2.0/seng-keycodes.js) (and [minified](http://mediamonks-development.s3.amazonaws.com/seng/libs/seng-keycodes/1.2.0/seng-keycodes-umd.min.js))
- [amd](http://mediamonks-development.s3.amazonaws.com/seng/libs/seng-keycodes/1.2.0/seng-keycodes-amd.js)
- [commonjs](http://mediamonks-development.s3.amazonaws.com/seng/libs/seng-keycodes/1.2.0/seng-keycodes-commonjs.js)
- [systemjs](http://mediamonks-development.s3.amazonaws.com/seng/libs/seng-keycodes/1.2.0/seng-keycodes-system.js)
- [es6](http://mediamonks-development.s3.amazonaws.com/seng/libs/seng-keycodes/1.2.0/seng-keycodes-es6.zip)

-->

### manual

Check the **build** section below to see your you can build for all the
targets yourself.

## Usage

```ts
import SengKeycodes from 'seng-keycodes';
// import SengKeycodes from 'seng-keycodes/lib/classname';

// do something with SengKeycodes
```


## Documentation

View the [generated documentation](https://rawgit.com/mediamonks/seng-keycodes/master/doc/typedoc/index.html).


## Building

In order to build seng-keycodes, ensure that you have [Git](http://git-scm.com/downloads)
and [Node.js](http://nodejs.org/) installed.

Clone a copy of the repo:
```sh
git clone https://github.com/mediamonks/seng-keycodes.git
```

Change to the seng-keycodes directory:
```sh
cd seng-keycodes
```

Install typings cli utility:
```sh
npm install typings --global
```

Install dev dependencies:
```sh
npm install
```

Use one of the following main scripts:
```sh
npm run build   		# build this project
npm run generate   		# generate all artifacts (compiles ts, webpack, docs and coverage)
npm run typings			# install .d.ts dependencies (done on install)
npm run test-unit    	# run the unit tests
npm run validate		# runs validation scripts, including test, lint and coverage check
npm run lint			# run tslint on this project
npm run doc				# generate typedoc documentation
npm run typescript-npm	# just compile the typescript output used in the npm module
```

When installing this module, it adds a pre-push hook, that runs the `validate`
script before committing, so you can be sure that everything checks out.

If you want to create the distribution files yourself, you can run the
`build-dist` script, and the following files will get generated in the
`dist` folder:

- **/dist/seng-keycodes.js**: bundled with webpack, can be loaded from
	a script tag, available as `window.SengKeycodes`
- **/dist/seng-keycodes.min.js**: same as above, but minified
- **/dist/seng-keycodes-amd.js**: bundled with webpack, can be used
	with e.g. requirejs
- **/dist/seng-keycodes-commonjs.js**: bundled with webpack, can be
	used in systems that support commonjs, but you should just use npm
- **/dist/seng-keycodes-umd.js**: bundled with webpack, works in the
	browser, with requirejs, and in a commonjs system
- **/dist/seng-keycodes-umd.min.js**: same as above, but minified
- **/dist/seng-keycodes-system.js**: bundled with typescript, can be
	used in systems	that support systemjs
- **/dist/seng-keycodes-es6.zip**: transpiled with typescript, only
	types are removed from the source files

## Contribute

View [CONTRIBUTING.md](./CONTRIBUTING.md)


## Changelog

View [CHANGELOG.md](./CHANGELOG.md)


## Authors

View [AUTHORS.md](./AUTHORS.md)


## LICENSE

[MIT](./LICENSE) © MediaMonks


